//@script_name SetQueryParameters
//@script_display_name Установить параметры запроса
//@script_description Вставляет в модуль шаблон для установки параметров запроса
//@script_author m.bolsun
//@script_developer_url http://turboconf.ru

//Скрипт будет вызываться по Control+Shift+Q
//@script_hotkey Control+Shift+Q

//Восстанавливать буфер обмена после завершения скрипта
//@retain_clipboard 1

//Скрипт доступен в режиме Предприятия
//@enterprise_mode 1

//Скрывать манипуляции с конфигуратором
//@hide_actions 1

Процедура ВставитьШаблонУстановкиПараметров()
	
	ТК = Новый ТурбоКонф; 

	Поз = 0;
	ВыделенныйТекст = "";
	
	Текст = ТК.ПолучитьТекстМодуля(ВыделенныйТекст, Поз); 
	
	//Отсекаем текст ниже от курсора
	Текст = Лев(Текст, Поз);
	
	//Ищем строки запроса
	
	//Найти все сопвадения, начинающиеся с выбрать или select, и все последующие за этим словом символы не кавычнки
	РегВыражение = Новый РегулярноеВыражение("(?:выбрать|select)[^""]+");
	
	РегВыражение.ИгнорироватьРегистр = Истина;
	
	Совпадения = РегВыражение.НайтиСовпадения(Текст);
	
	Если Совпадения.Количество() = 0 Тогда
		
		Возврат;	
	
	КонецЕсли;
	
	//Берем последнее совпадение, это искомый текст запроса
	
	ТекстЗапроса = Совпадения[Совпадения.Количество()-1].Значение;
	
	//Ищем параметры
	
	//Найти все сопадения, которые начинаются с символа & и следующими за ним буквами, цифрами и _
	//Имя параметра поместить в группу
	РегВыражение = Новый РегулярноеВыражение("&([\w\d_]+)");
	
	Совпадения = РегВыражение.НайтиСовпадения(ТекстЗапроса);
	
	Если Совпадения.Количество() = 0 Тогда
		
		Возврат;	
	
	КонецЕсли;
		
	//Заполняем список только уникальными параметрами

	Параметры = Новый СписокЗначений;

	Для каждого Совпадение Из Совпадения Цикл
		
		Параметр = Совпадение.Группы[1].Значение;
		
		Если Параметры.НайтиПоЗначению(Параметр) = Неопределено Тогда
			Параметры.Добавить(Параметр);
		КонецЕсли;
	
	КонецЦикла;
	
	//Формируем текст для вставки

	ТекстШаблона = "";
	
	Для каждого Параметр Из Параметры Цикл
		
		ТекстШаблона = ТекстШаблона + "Запрос.УстановитьПараметр(""" + Параметр.Значение + """, );";
		ТекстШаблона = ТекстШаблона + Символы.ПС;
	
	КонецЦикла;

	ТК.ВставитьТекст(ТекстШаблона);

КонецПроцедуры

ВставитьШаблонУстановкиПараметров();

